package at.gv.egiz.moazs;

import org.apache.commons.io.FileUtils;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.nio.charset.StandardCharsets;
import java.util.GregorianCalendar;

import static java.net.http.HttpResponse.BodyHandlers.ofString;

public class TestUtils {

    public static String formatFile(String path, String... values) throws IOException {
        var templateString = FileUtils.readFileToString(new File(path), StandardCharsets.UTF_8);
        return String.format(templateString, values);
    }

    public static HttpResponse<String> sendSOAP(String endpoint, String bodyString) throws IOException, InterruptedException {

        var body = HttpRequest.BodyPublishers.ofString(bodyString);
        var client = HttpClient.newBuilder().version(HttpClient.Version.HTTP_1_1).build();
        var request = HttpRequest.newBuilder()
                .uri(URI.create(endpoint))
                .header("Content-Type", "text/xml;charset=UTF-8")
                .header("SOAPAction", "\"\"")
                .POST(body)
                .build();

        return client.send(request, ofString());

    }

    public static XMLGregorianCalendar genTimeStamp() {
        try {
            return DatatypeFactory.newInstance().newXMLGregorianCalendar(new GregorianCalendar());
        } catch (DatatypeConfigurationException e) {
            throw new RuntimeException("ups");
        }

    }
}
